


;This is the main include file for Crabcake.  There
;are two macros: Crabcake_START, and Crabcake_END.



;These two variables keep track of which bytes need
;to be swapped, because swapping occurs if the calculator
;is not a normal Ti-83+

Page0Location .equ savesscreen + 513
Page3Location .equ savesscreen + 515


;The stack is temporarily destroyed during page swapping,
;so we can't use calls.  We instead use jump (ix)

JumpLocation .equ savesscreen + 517


#macro Crabcake_START

;When a large ASM program starts in a shell, the
;program is copied, and then this macro will do either
;one of two things:

;1. For a Ti-83+, it will unlock page $80 so that
;   code can run from the page safely

;2. For a Ti-83+ SE or a Ti-84+, code on pages $80 and $83
;   will be swapped, and then page $83 will take the place
;   of page $80



Check_If_Normal_Or_15Mhz:

	di


;Is the calculator a normal Ti-83+, or not?

	in a, ($02)
	rla
	
;If the carry flag is not set, the calculator is not a standard Ti-83+


	jp c, Is15MhzCalculator

#ifdef Not83Plus
	
	ret
#else


	jp Is6MhzCalculator

#endif

#ifndef Not83Plus	;Leave out the Ti-83+ BE code if
			;the program is not intended for the calculator


;This code is needed to unlock the flash on a standard Ti-83+
#include "Unlock.asm"
	


Is6MhzCalculator:

    	in a,(6)
        push af
	call FlashUnlockExploit

;Save the page where code is running.


;Flash is unlocked, so we can use another
;exploit to unlock RAM page 0.  It is on page
;$1F, and we start searching for it at
;$4000

	call FindRoutine
	
	xor a
	ld de, AfterExploit
	push de

	jp (hl)		





AfterExploit:

	B_CALL $4F3C
	pop af
	out ($06), a

	jp EndOne


#endif



Is15MhzCalculator:

;Temporarily put page $83 into the $4000-$7FFF section so
;that we can swap bytes with RAM page $80


	in a, ($06)
	
	push af

;Code can run on flash page $83, so put this in the place
;of flash page $80
	
	ld a, $83
	out ($06), a
	
	ld hl, SwapBytesEnd
	ld (JumpLocation), hl
	

#include "Swap.asm"

;Swap the pages


;Put page $83 into the slot where page $80 normally is

	ld a, $03	;Port 5 CANNOT accept values in the 80s :)

	out ($05), a

	pop af
	out ($06), a

	jp EndOne





EndOne:
	ei

#endmacro




#macro Crabcake_END


End_Program:

	
Wrap_It_Up:



;Is the calculator a normal Ti-83+, or not?

	di

#ifndef Not83plus
	in a, ($02)
	rla
	
;If the value is NOT zero, the calculator is not a standard Ti-83+


	jp c, End_Is15MhzCalculator


	

End_Is6MhzCalculator:

    	in a,(6)
        push af

	call FlashUnlockExploit


	ld hl, SixMhzCleanUp
	ld de, tempswaparea
	ld bc, SixMhzCleanUpEnd - SixMhzCleanUp
	ldir
	jp tempswaparea



SixMhzCleanup:




	call FindRoutine

;Lock RAM page 0.

	ld a, %00000111

	ld de, $ + 5 - SixMhzCleanup + tempswaparea
	push de

	jp (hl)	


End_AfterExploit:

	B_CALL $4F3C

	pop af
	out ($06), a

	ei
	ret



SixMhzCleanUpEnd:

#endif

End_Is15MhzCalculator:


;Right now, RAM page $83 is in the $C000-FFFF section.  Put RAM page $80
;into the $4000-$7FFF section so that bytes can be swapped.

	

	in a, ($06)
	

	push af
	
	ld a, $80
	out ($06), a

	ld hl, tempswaparea
	ld (JumpLocation), hl

	ld hl, Wrap_It_Up_Up
	ld de, tempswaparea
	ld bc, Wrap_It_Up_Code_End - Wrap_It_Up_Code
	ldir

	jp SwapBytes	

Wrap_It_Up_Up:

Wrap_It_Up_Code:

	xor a

	out ($05), a

	pop af
	out ($06), a

EndTwo:
	ei
	ret	;If the user did everything correctly, this
		;will completely end the ASM program.

Wrap_It_Up_Code_End










#endmacro
